﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Web;
using System.Net;
using System.IO;

namespace Dictionary
{
    class CWiki : CSearch
    {
        override public string Get(string SearchText)
        {
            SetNotice("データ取得開始");

            string SavePath = GetExePath() + @"\data\wiki\" + SearchText + ".html";

            /* ファイルが存在するか確認する */
            if (!File.Exists(SavePath))
            {
                string Output;
                string Buffer;

                try
                {
                    /* 無かったらダウンロード */
                    Buffer = HTTPDownload("http://ja.wikipedia.org/wiki/" +
                        HttpUtility.UrlEncode(SearchText, Encoding.UTF8).ToUpper(),Encoding.UTF8);
                }
                catch
                {
                    SetNotice("ネットワークエラーが発生しました。");
                    return Page_Error;
                }

                /* 結果が無かったら、エラーを出す */
                if (Buffer.IndexOf("検索結果に該当するものが見当たりません。") != -1)
                {
                    SetNotice("検索結果に該当するものが見あたりません。");
                    return Page_Error;
                }

                Output = Analyze(Buffer);

                SaveFile(SavePath, Output);

                SetNotice("データキャッシュ完了");
            }
            else
            {
                SetNotice("キャッシュより取得");
            }

            return SavePath;
        }

        private string Analyze(string Buffer)
        {
            string Output;

            int StartTag = Buffer.IndexOf("<h1 class=\"firstHeading\">");
            int EndTag = Buffer.IndexOf("<div class=\"visualClear\">");

            Buffer = Buffer.Substring(StartTag, EndTag - StartTag);

            Output = Buffer;

            return Output;
        }
    }
}
