﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Web;
using System.Net;
using System.IO;

namespace Dictionary
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            /* 初期のウィンドウサイズを取得する */
            mBeforeWindowSize = Size;

            /* 最初のページを開く */
            webBrowser1.Url = new Uri("about:blank");

            /* 初期ステータスの表示 */
            textBox_notice.Text = "起動完了\r\n";
        }

        /// <summary>
        /// ウィンドウのサイズ変更に使う変数
        /// </summary>
        private Size mBeforeWindowSize = new Size();

        /// <summary>
        /// IEコンポーネントのリサイズ
        /// </summary>
        private void ReSize(object sender, EventArgs e)
        {
            Size mNowWindowSize = Size;

            /* サイズ変更されたサイズを取得 */
            int MoveHieght = mNowWindowSize.Height - mBeforeWindowSize.Height;
            int MoveWidth = mNowWindowSize.Width - mBeforeWindowSize.Width;

            Size WebBrowserSize = new Size();
            WebBrowserSize = webBrowser1.Size;

            WebBrowserSize.Height += MoveHieght;
            WebBrowserSize.Width += MoveWidth;

            webBrowser1.Size = WebBrowserSize;

            /* 最後に、今のサイズを代入 */
            mBeforeWindowSize = Size;
        }

        /// <summary>
        /// 検索
        /// </summary>
        private void button_search_Click(object sender, EventArgs e)
        {
            /* 文字が入力されていなかったときの処理 */
            if (textBox_search_text.Text.Trim() == "")
            {
                return;
            }

            /* 検索文字列の表示 */
            string temp = textBox_notice.Text;
            textBox_notice.Text = ("--「" + textBox_search_text.Text + "」を検索します。--\r\n");
            textBox_notice.Text += temp;

            /* URLの設定 */
            if (radioButton_ej.Checked == true)
            {
                string SavePath;

                CEn_Jp ej = new CEn_Jp((int)numericUpDown_result_number.Value, GetSearchMode_Goo());
                ej.SetNoticeArea(textBox_notice);
                SavePath = ej.Get(textBox_search_text.Text);

                /* ファイルオープン */
                Uri mUri = new Uri("file://" + SavePath);
                webBrowser1.Url = mUri;
            }

            if (radioButton_je.Checked == true)
            {
                string SavePath;

                CJp_En je = new CJp_En((int)numericUpDown_result_number.Value, GetSearchMode_Goo());
                je.SetNoticeArea(textBox_notice);
                SavePath = je.Get(textBox_search_text.Text);

                /* ファイルオープン */
                Uri mUri = new Uri("file://" + SavePath);
                webBrowser1.Url = mUri;
            }

            if (radioButton_jp.Checked == true)
            {
                string SavePath;

                CJn jn = new CJn((int)numericUpDown_result_number.Value, GetSearchMode_Goo());
                jn.SetNoticeArea(textBox_notice);
                SavePath = jn.Get(textBox_search_text.Text);

                /* ファイルオープン */
                Uri mUri = new Uri("file://" + SavePath);
                webBrowser1.Url = mUri;
            }

            if (radioButton_wiki.Checked == true)
            {
                string SavePath;

                CWiki wiki = new CWiki();
                wiki.SetNoticeArea(textBox_notice);
                SavePath = wiki.Get(textBox_search_text.Text);

                /* ファイルオープン */
                Uri mUri = new Uri("file://" + SavePath);
                webBrowser1.Url = mUri;
            }
        }

        /// <summary>
        /// gooの辞書にたいしての検索を行うときのモード選択
        /// </summary>
        /// <returns></returns>
        private SearchMode_Goo GetSearchMode_Goo()
        {
            if(radioButton_after.Checked)
            {
                return SearchMode_Goo.After;
            }
            if(radioButton_before.Checked)
            {
                return SearchMode_Goo.Before;
            }
            if(radioButton_complete.Checked)
            {
                return SearchMode_Goo.Complete;
            }
            if(radioButton_explain.Checked)
            {
                return SearchMode_Goo.Explain;
            }

            return SearchMode_Goo.Complete;
        }

        /// <summary>
        /// 文字列のShift_JISからEUC-JPへのエンコーディング
        /// </summary>
        /// <param name="Buffer"></param>
        /// <returns></returns>
        private string EncodingString(string Buffer)
        {
            Encoding sjis = Encoding.GetEncoding("Shift_JIS");
            Encoding euc = Encoding.GetEncoding("EUC-JP");

            byte[] Bytes = euc.GetBytes(Buffer);

            Bytes = Encoding.Convert(sjis, euc, Bytes);

            char[] charBytes = new char[euc.GetCharCount(Bytes, 0, Bytes.Length)];
            euc.GetChars(Bytes, 0, Bytes.Length, charBytes, 0);
            return new string(charBytes);

        }

        /// <summary>
        /// 戻る
        /// </summary>
        private void button_back_forward_Click(object sender, EventArgs e)
        {
            webBrowser1.GoBack();
        }

        /// <summary>
        /// 進む
        /// </summary>
        private void button_forward_Click(object sender, EventArgs e)
        {
            webBrowser1.GoForward();
        }

        /// <summary>
        /// 終了
        /// </summary>
        private void button_exit(object sender, EventArgs e)
        {
            Application.Exit();
        }

        /// <summary>
        /// エンターキーで検索を行う
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox_search_text_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                button_search_Click(null,null);
            }
        }

        /// <summary>
        /// ウィンドウが非アクティブにされたとき
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Deactivate(object sender, System.EventArgs e)
        {
            if (this.WindowState == FormWindowState.Minimized)
            {
                ShowInTaskbar = false;
                this.Hide();
            }
        }

        /// <summary>
        /// 常駐トレイのアイコンがクリックされたとき
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void notifyIcon1_Click(object sender, System.EventArgs e)
        {
            ShowInTaskbar = true;
            this.Show() ;
            this.WindowState = FormWindowState.Normal;
        }

        /// <summary>
        /// 常駐ボタンが押されたとき
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_mini_Click(object sender, EventArgs e)
        {
            ShowInTaskbar = false;
            this.Hide();
        }

        protected void menu_exit_click(object s, System.EventArgs e)
        {
            button_exit(null,null);
        }

        protected void menu_show_click(object s, System.EventArgs e)
        {
            notifyIcon1_Click(null, null);
        }
    }
}